## mavlink-MAVSDK.zip

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

option(HUNTER_ENABLED "Enable Hunter package manager support" OFF)
option(SUPERBUILD "Build dependencies" ON)
option(BUILD_MAVSDK_SERVER "Build mavsdk_server" OFF)
option(BUILD_WITH_PROTO_REFLECTION "Build mavsdk_server with proto reflection" OFF)
option(BUILD_SHARED_LIBS "Build core as shared libraries instead of static ones" ON)
option(MAVLINK_DIALECT "MAVLink dialect. Default: common" "common")
option(BUILD_TESTING "Build tests" ON)

if (SUPERBUILD AND HUNTER_ENABLED)
    message(FATAL_ERROR "Cannot SUPERBUILD while HUNTER_ENABLED. Set -DSUPERBUILD=OFF when using Hunter")
endif()

if (NOT MAVLINK_DIALECT)
    set(MAVLINK_DIALECT "common")
endif()

execute_process(
    COMMAND git describe --abbrev=8 --dirty --always --tags
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    OUTPUT_VARIABLE VERSION_STR
    OUTPUT_STRIP_TRAILING_WHITESPACE
    RESULT_VARIABLE GITVER
)

if (NOT GITVER EQUAL "0")
    message(STATUS "No git version found. Falling back to empty version no")
    set(VERSION_STR "0.0.0")
endif()

message(STATUS "Version: ${VERSION_STR}")
STRING(REGEX REPLACE v\([0-9]+\).[0-9]+.[0-9]+.*$ \\1 MAVSDK_VERSION_MAJOR "${VERSION_STR}")
STRING(REGEX REPLACE v[0-9]+.\([0-9]+\).[0-9]+.*$ \\1 MAVSDK_VERSION_MINOR "${VERSION_STR}")
STRING(REGEX REPLACE v[0-9]+.[0-9]+.\([0-9]+\).*$ \\1 MAVSDK_VERSION_PATCH "${VERSION_STR}")

message(STATUS "Version major: ${MAVSDK_VERSION_MAJOR}")
message(STATUS "Version minor: ${MAVSDK_VERSION_MINOR}")
message(STATUS "Version patch: ${MAVSDK_VERSION_PATCH}")

set(MAVSDK_SOVERSION_STRING ${MAVSDK_VERSION_MAJOR})
set(MAVSDK_VERSION_STRING ${MAVSDK_VERSION_MAJOR}.${MAVSDK_VERSION_MINOR}.${MAVSDK_VERSION_PATCH})

include("src/cmake/HunterGate.cmake")
HunterGate(
    URL "https://github.com/cpp-pm/hunter/archive/v0.23.315.tar.gz"
    SHA1 "ea5d72afc0df67f2126e7fd069f20c5f723709e1"
)

project(mavsdk_superbuild)

if (BUILD_BACKEND)
    message(FATAL_ERROR "The argument BUILD_BACKEND has been replaced by BUILD_MAVSDK_SERVER. To build mavsdk_server, use -DBUILD_MAVSDK_SERVER=ON.")
endif()

set(DEPS_BUILD_PATH "${PROJECT_BINARY_DIR}/third_party" CACHE PATH "Install path for the dependencies. Ignored if SUPERBUILD=OFF.")
set(DEPS_INSTALL_PATH "${DEPS_BUILD_PATH}/install" CACHE PATH "Install path for the dependencies. Ignored if SUPERBUILD=OFF.")

include(GNUInstallDirs)

add_subdirectory(third_party)
add_subdirectory(src)

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)
project(mavsdk_examples)

# This allows to build all examples at once.

if (WERROR)
    add_compile_options(-Werror)
endif()

add_subdirectory(arm_authorizer_server)
add_subdirectory(autopilot_server)
add_subdirectory(battery)
add_subdirectory(calibrate)
add_subdirectory(camera)
add_subdirectory(camera_server)
add_subdirectory(camera_settings)
add_subdirectory(camera_zoom)
add_subdirectory(component_metadata)
add_subdirectory(disconnect)
add_subdirectory(reconnect)
add_subdirectory(fly_mission)
add_subdirectory(fly_multiple_drones)
add_subdirectory(fly_qgc_mission)
add_subdirectory(follow_me)
add_subdirectory(mavlink_forwarding)
add_subdirectory(ftp_client)
add_subdirectory(ftp_server)
add_subdirectory(geofence)
add_subdirectory(gimbal)
add_subdirectory(gimbal_device_tester)
add_subdirectory(log_callback)
add_subdirectory(logfile_download)
add_subdirectory(log_streaming)
add_subdirectory(manual_control)
add_subdirectory(mavshell)
add_subdirectory(multiple_drones)
add_subdirectory(offboard)
add_subdirectory(parachute)
add_subdirectory(set_actuator)
add_subdirectory(sniffer)
add_subdirectory(system_info)
add_subdirectory(takeoff_and_land)
add_subdirectory(terminate)
add_subdirectory(transponder)
add_subdirectory(tune)
add_subdirectory(vtol_transition)
add_subdirectory(winch)

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

cmake_policy(SET CMP0025 NEW)

project(mavsdk)

# ccache
option(CCACHE "Use ccache if available" ON)
find_program(CCACHE_PROGRAM ccache)
if(CCACHE AND CCACHE_PROGRAM AND NOT DEFINED ENV{CCACHE_DISABLE})

    get_filename_component(ccache_real_path ${CCACHE_PROGRAM} REALPATH)
    get_filename_component(cxx_real_path ${CMAKE_CXX_COMPILER} REALPATH)
    get_filename_component(cxx_abs_path ${CMAKE_CXX_COMPILER} ABSOLUTE)

    if ("${ccache_real_path}" STREQUAL "${cxx_real_path}")
        message(STATUS "ccache enabled via symlink (${cxx_abs_path} -> ${cxx_real_path})")
    else()
        message(STATUS "ccache enabled (export CCACHE_DISABLE=1 to disable)")
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
    endif()
endif()

option(BUILD_TESTING "Build tests" ON)
option(CMAKE_POSITION_INDEPENDENT_CODE "Position independent code" ON)

include(cmake/compiler_flags.cmake)

find_package(Threads REQUIRED)

if(NOT HUNTER_ENABLED)
    list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")
endif()

# This will noop if hunter is not enabled
hunter_add_package(jsoncpp)
hunter_add_package(CURL)
hunter_add_package(lzma)

find_package(CURL REQUIRED)
find_package(LibLZMA REQUIRED)

if(BUILD_TESTING AND (IOS OR ANDROID))
    message(STATUS "Building for iOS or Android: forcing BUILD_TESTING to FALSE...")
    set(BUILD_TESTING OFF)
endif()

if(ANDROID)
    set(lib_path "lib/android/${ANDROID_ABI}")
elseif(IOS)
    set(lib_path "lib/ios")
else()
    set(lib_path "lib")
endif()

if (ENABLED_PLUGINS)
    message(STATUS "Manually enabled plugins:")
    foreach(plugin ${ENABLED_PLUGINS})
        message(STATUS "  - ${plugin}")
    endforeach()
else()
    message(STATUS "All plugins enabled")
    file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/plugins.txt" ENABLED_PLUGINS)
endif()

add_subdirectory(mavsdk)

include(cmake/static_analyzers.cmake)

if(BUILD_TESTING)
    enable_testing()

    add_subdirectory(integration_tests)
    add_subdirectory(unit_tests)
    add_subdirectory(system_tests)
endif()

if (BUILD_MAVSDK_SERVER)
    message(STATUS "Building mavsdk server")
    add_subdirectory(mavsdk_server)
else()
    message(STATUS "BUILD_MAVSDK_SERVER not set: not building grpc mavsdk_server")
endif()

install(EXPORT mavsdk-targets
    FILE MAVSDKTargets.cmake
    NAMESPACE MAVSDK::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/MAVSDK
    )

# For the build tree
configure_file(MAVSDKConfig.cmake.in
    "${PROJECT_BINARY_DIR}/MAVSDKConfig.cmake" @ONLY)
# For the install tree
configure_file(MAVSDKConfig.cmake.in
    "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/MAVSDKConfig.cmake" @ONLY)

# Pkg-config
configure_file(mavsdk.pc.in
    "${PROJECT_BINARY_DIR}/mavsdk.pc" @ONLY)

include(CMakePackageConfigHelpers)
# Supply version to config
write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/MAVSDKConfigVersion.cmake
    VERSION ${MAVSDK_VERSION_MAJOR}.${MAVSDK_VERSION_MINOR}.${MAVSDK_VERSION_PATCH}
    COMPATIBILITY SameMajorVersion )

install(FILES
    "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/MAVSDKConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/MAVSDKConfigVersion.cmake"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/MAVSDK)

install(FILES
    "${PROJECT_BINARY_DIR}/mavsdk.pc"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== third_party/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)

project(third_party)

include(cmake/build_target.cmake)

list(APPEND CMAKE_PREFIX_PATH "${DEPS_INSTALL_PATH}")
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} PARENT_SCOPE)

if(SUPERBUILD)
    build_target(mavlink)
    build_target(jsoncpp)
    build_target(tinyxml2)
    build_target(liblzma)

    if(NOT BUILD_WITHOUT_CURL)
        build_target(openssl)

        if(NOT IOS)
            build_target(zlib-ng)
        endif()

        build_target(curl)
    endif()

    if(BUILD_MAVSDK_SERVER)
        if (BUILD_WITHOUT_CURL)
            build_target(openssl)
        endif()

        build_target(cares)
        build_target(absl)
        build_target(protobuf)
        build_target(re2)
        build_target(grpc)
    endif()

    if(BUILD_TESTING)
        build_target(gtest)
    endif()

endif()

build_target(libevents)

if(ENABLE_CPPTRACE)
    build_target(cpptrace)
endif()

=== examples/arm_authorizer_server/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

project(arm_authorizer_server)

add_executable(arm_authorizer_server
        arm_authorizer_server.cpp
)

find_package(MAVSDK REQUIRED)

target_link_libraries(arm_authorizer_server
        MAVSDK::mavsdk
)

if (NOT MSVC)
    add_compile_options(arm_authorizer_server PRIVATE -Wall -Wextra)
else ()
    add_compile_options(arm_authorizer_server PRIVATE -W2)
endif ()

=== examples/autopilot_server/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

project(autopilot_server)

add_executable(autopilot_server
    autopilot_server.cpp
)

find_package(MAVSDK REQUIRED)
find_package(Threads REQUIRED)

target_link_libraries(autopilot_server
    MAVSDK::mavsdk
    Threads::Threads
)

if(NOT MSVC)
    add_compile_options(autopilot_server PRIVATE -Wall -Wextra)
else()
    add_compile_options(autopilot_server PRIVATE -W2)
endif()

=== examples/battery/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

project(battery)

add_executable(battery
    battery.cpp
)

find_package(MAVSDK REQUIRED)

target_link_libraries(battery
    MAVSDK::mavsdk
)

if(NOT MSVC)
    add_compile_options(battery PRIVATE -Wall -Wextra)
else()
    add_compile_options(battery PRIVATE -W2)
endif()

=== examples/calibrate/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

project(calibrate)

add_executable(calibrate
    calibrate.cpp
)

find_package(MAVSDK REQUIRED)

target_link_libraries(calibrate
    MAVSDK::mavsdk
)

if(NOT MSVC)
    add_compile_options(calibrate PRIVATE -Wall -Wextra)
else()
    add_compile_options(calibrate PRIVATE -W2)
endif()

=== examples/camera/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

project(camera)

add_executable(camera
    camera.cpp
)

find_package(MAVSDK REQUIRED)

target_link_libraries(camera
    MAVSDK::mavsdk
)

if(NOT MSVC)
    add_compile_options(camera PRIVATE -Wall -Wextra)
else()
    add_compile_options(camera PRIVATE -W2)
endif()

=== examples/camera_server/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

project(camera_server)

add_executable(camera_server
    camera_server.cpp
)

add_executable(camera_client
    camera_client.cpp
)

find_package(MAVSDK REQUIRED)

target_link_libraries(camera_server
    MAVSDK::mavsdk
)

target_link_libraries(camera_client
    MAVSDK::mavsdk
)

if(NOT MSVC)
    add_compile_options(camera_server PRIVATE -Wall -Wextra)
else()
    add_compile_options(camera_server PRIVATE -W2)
endif()

=== examples/camera_settings/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

project(camera_settings)

add_executable(camera_settings
    camera_settings.cpp
)

find_package(MAVSDK REQUIRED)

target_link_libraries(camera_settings
    MAVSDK::mavsdk
)

if(NOT MSVC)
    add_compile_options(camera_settings PRIVATE -Wall -Wextra)
else()
    add_compile_options(camera_settings PRIVATE -W2)
endif()

=== examples/camera_zoom/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

project(camera_zoom)

add_executable(camera_zoom
    camera_zoom.cpp
)

find_package(MAVSDK REQUIRED)

target_link_libraries(camera_zoom
    MAVSDK::mavsdk
)

if(NOT MSVC)
    add_compile_options(camera_zoom PRIVATE -Wall -Wextra)
else()
    add_compile_options(camera_zoom PRIVATE -W2)
endif()

=== debian/control ===
Source: mavsdk
Priority: optional
Maintainer: hcb <hcb@archaeopteryx>
Build-Depends: debhelper (>= 11), libjsoncpp-dev, libcurl4-openssl-dev, libtinyxml2-dev
Standards-Version: 4.1.3
Section: libs
Homepage: https://mavsdk.mavlink.io/main/en/index.html
Vcs-Browser: https://github.com/mavlink/MAVSDK
Vcs-Git: https://github.com/mavlink/MAVSDK.git

Package: libmavsdk-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmavsdk0 (= ${binary:Version}), ${misc:Depends}
Description: MAVSDK API for Mavlink-controlled vehicles
 This provides the development headers for the mavsdk C++ library.

Package: libmavsdk0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libjsoncpp1, libcurl4, libtinyxml2-6a
Description: MAVSDK API for Mavlink-controlled vehicles
 This provides the runtime libraries for the mavsdk C++ library.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

%:
	dh $@ --without=build-stamp --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -O--buildsystem=cmake -O--builddirectory=build -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DBUILD_SHARED_LIBS=ON \
		-DBUILD_TESTING=OFF \
		-DSUPERBUILD=OFF \
		-DCMAKE_INSTALL_PREFIX=/usr
